.\" Copyright (c) 1983, 1991, 1993
.\"	The Regents of the University of California.  All rights reserved.
.\"
.\" Redistribution and use in source and binary forms, with or without
.\" modification, are permitted provided that the following conditions
.\" are met:
.\" 1. Redistributions of source code must retain the above copyright
.\"    notice, this list of conditions and the following disclaimer.
.\" 2. Redistributions in binary form must reproduce the above copyright
.\"    notice, this list of conditions and the following disclaimer in the
.\"    documentation and/or other materials provided with the distribution.
.\" 3. All advertising materials mentioning features or use of this software
.\"    must display the following acknowledgement:
.\"	This product includes software developed by the University of
.\"	California, Berkeley and its contributors.
.\" 4. Neither the name of the University nor the names of its contributors
.\"    may be used to endorse or promote products derived from this software
.\"    without specific prior written permission.
.\"
.\" THIS SOFTWARE IS PROVIDED BY THE REGENTS AND CONTRIBUTORS ``AS IS'' AND
.\" ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
.\" IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
.\" ARE DISCLAIMED.  IN NO EVENT SHALL THE REGENTS OR CONTRIBUTORS BE LIABLE
.\" FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
.\" DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
.\" OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
.\" HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
.\" LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
.\" OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
.\" SUCH DAMAGE.
.\"
.\"     @(#)chroot.2	8.1 (Berkeley) 6/4/93
.\"
.Dd June 4, 1993
.Dt CHROOT 2
.Os BSD 4.2
.Sh NAME
.Nm chroot
.Nd change root directory
.Sh SYNOPSIS
.Fd #include <unistd.h>
.Ft int
.Fn chroot "const char *dirname"
.Sh DESCRIPTION
.Fa Dirname
is the address of the pathname of a directory, terminated by an ASCII NUL.
.Fn Chroot
causes
.Fa dirname
to become the root directory,
that is, the starting point for path searches of pathnames
beginning with
.Ql / .
.Pp
In order for a directory to become the root directory
a process must have execute (search) access for that directory.
.Pp
It should be noted that
.Fn chroot
has no effect on the process's current directory.
.Pp
This call is restricted to the super-user.
.Sh RETURN VALUES
Upon successful completion, a value of 0 is returned.  Otherwise,
a value of -1 is returned and
.Va errno
is set to indicate an error.
.Sh ERRORS
.Fn Chroot
will fail and the root directory will be unchanged if:
.Bl -tag -width [ENOTDIR]
.It Bq Er ENOTDIR
A component of the path name is not a directory.
.It Bq Er EPERM
The effective user ID is not the super-user.
.It Bq Er ENAMETOOLONG
A component of a pathname exceeded 255 characters,
or an entire path name exceeded 1023 characters.
.It Bq Er ENOENT
The named directory does not exist.
.It Bq Er EACCES
Search permission is denied for any component of the path name.
.It Bq Er ELOOP
Too many symbolic links were encountered in translating the pathname.
.It Bq Er EFAULT
.Fa Path
points outside the process's allocated address space.
.It Bq Er EIO
An I/O error occurred while reading from or writing to the file system.
.El
.Sh SEE ALSO
.Xr chdir 2
.Sh HISTORY
The
.Fn chroot
function call appeared in
.Bx 4.2 .
